<template>
  <div class="app-container">
    <!--筛选条件-->
    <div class="search-div">
      <el-form ref="selectForm" :inline="true" :model="listQuery" class="form-container">
        <el-row>
          <el-form-item class="selectForm-container-item" prop="keywords">
            <el-input v-model.trim="listQuery.keywords" placeholder="窨井编号" clearable/>
          </el-form-item>
          <el-form-item v-if="isOperation()" class="selectForm-container-item" prop="alarmType">
            <el-select v-model="listQuery.alarmType" placeholder="告警类型" clearable>
              <el-option
                v-for="item in alarmTypeList"
                :key="item.value"
                :label="item.name"
                :value="item.value"/>
            </el-select>
          </el-form-item>
          <el-form-item class="selectForm-container-item" prop="alarmType">
            <el-select :disabled="alarmContentTypeList.length>0?false:true" v-model="listQuery.alarmContentType" placeholder="告警内容" clearable>
              <el-option
                v-for="item in alarmContentTypeList"
                :key="item.value"
                :label="item.name"
                :value="item.value"/>
            </el-select>
          </el-form-item>
          <el-form-item class="selectForm-container-item" prop="beginTime">
            <el-date-picker
              v-model="timeRange"
              type="datetimerange"
              range-separator="至"
              value-format="yyyy-MM-dd HH:mm:ss"
              start-placeholder="报警开始时间"
              end-placeholder="报警结束时间"/>
          </el-form-item>
          <el-button class="filter-item" type="primary" icon="el-icon-search" @click="search">搜索</el-button>
        </el-row>
      </el-form>
    </div>
    <!--查询结果Table显示-->
    <div>
      <el-row class="table-title">
        <el-col :span="6"><div class="title-header"><i class="el-icon-menu"/>数据列表</div></el-col>
        <el-col :span="12" :offset="6" class="edit_btns">
          <el-button v-if="hasPerm('/alarm/export')" class="edit_btn" size="small" @click="batchExport">导出记录</el-button>
          <el-button v-if="hasPerm('/alarm/batchCancel')" class="edit_btn" size="small" @click="batchCancel">批量消警</el-button>
        </el-col>
      </el-row>
      <el-table v-loading="listLoading" :data="list" :row-class-name="tableRowClassName" class="table" border>
        <el-table-column :index="indexMethod" align="center" type="index" />
        <el-table-column label="窨井编号" align="center" show-overflow-tooltip>
          <template slot-scope="scope">
            <el-button type="text" @click="showWellDetail(scope.row)">{{ scope.row.wellCode }}</el-button>
          </template>
        </el-table-column>
        <el-table-column v-for="column in columns" :key="column.value" :label="column.text" :width="column.width" :align="column.align" :formatter="column.formatFun" show-overflow-tooltip>
          <template slot-scope="scope">
            <span v-if="column.checkCell" :class="checkCell(scope.row.cell)">{{ scope.row[column.value] }}</span>
            <span v-else-if="column.level">{{ formatValue(scope.row[column.value]) }}</span>
            <span v-else>{{ scope.row[column.value] }}</span>
          </template>
        </el-table-column>
        <el-table-column v-if="hasPerm('/alarm/cancelAlarm')" label="操作" align="center" >
          <template slot-scope="scope">
            <el-button type="danger" size="small" @click="cancelAlarm(scope.row.jobId)">取消报警</el-button>
          </template>
        </el-table-column>
      </el-table>
    </div>
    <!--分页-->
    <div class="pagination-container">
      <el-pagination
        v-show="total>listQuery.limit"
        :current-page="listQuery.offset"
        :page-sizes="[20,30,50]"
        :page-size="listQuery.limit"
        :total="total"
        align="center"
        layout="total, sizes, prev, pager, next"
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"/>
    </div>
    <info-well v-show="wellShow" ref="wellInfo"/>
    <handle-prompt ref="handlePrompt" @watchChild="fetchData"/>
  </div>
</template>

<script>
import infoWell from '@/views/wellManage/infoWell'
import { getAlarmList, batchExportAlarm, getAlarmType, getAlarmContentType } from '@/api/alarm'
import HandlePrompt from './components/HandlePrompt'
import { isOperation } from '@/utils/permission'

export default {
  name: 'ListAlarmNow',
  components: { HandlePrompt, infoWell },
  data() {
    return {
      listQuery: {
        keywords: '',
        alarmType: '',
        alarmContentType: '',
        beginTime: '',
        endTime: '',
        status: '1',
        offset: 1,
        limit: 20,
        sort: '',
        order: ''
      }, // 筛选条件
      timeRange: [], // 时间范围
      columns: [
        {
          text: '设备编号',
          value: 'devcode',
          align: 'center'
        },
        {
          text: '详细地址',
          value: 'position',
          align: 'center'
        },
        {
          text: '告警类型',
          value: 'alarmTypeName',
          align: 'center'
        },
        {
          text: '告警原因',
          value: 'alarmContentName',
          align: 'center'
        },
        {
          text: '告警等级',
          value: 'alarmLevel',
          align: 'center',
          level: true
        },
        {
          text: '告警数值',
          value: 'alarmValue',
          width: 90,
          align: 'center',
          checkCell: true
        },
        {
          text: '权属单位',
          value: 'deptName',
          align: 'center'
        },
        {
          text: '告警时间',
          value: 'alarmTime',
          width: 170,
          align: 'center'
        }
        // {
        //   text: '联系人',
        //   value: 'staff',
        //   align: 'center'
        // },
        // {
        //   text: '联系方式',
        //   value: 'tel',
        //   width: 110,
        //   align: 'center'
        // }
      ], // 显示列
      multipleSelection: [], // 多选选中项
      list: [], // 列表数据
      total: 0, // 数据总数
      deviceTypeList: [], // 集中器类型列表
      deptProps: {
        parent: 'pid',
        value: 'id',
        label: 'name',
        children: 'children'
      }, // 权属单位树形下拉菜单
      deptTreeList: null, // 组织树列表数据
      showDeptTree: 0, // 是否显示权属单位下拉
      alarmTypeList: [], // 告警类型列表
      alarmContentTypeList: [], // 告警内容类型列表
      showAlarmType: true, // 是否显示告警类型下拉
      listLoading: true, // 加载动画
      fullscreenLoading: false, // 全屏加载动画
      wellShow: false, // 是否显示窨井详情
      detailShow: false, // 是否显示编辑框
      cancelShow: false // 是否显示取消报警原因弹窗
    }
  },
  computed: {
    alarmType() {
      return this.listQuery.alarmType
    }
  },
  watch: {
    // 当告警各类型变化时，刷新告警内容列表
    alarmType(val) {
      this.listQuery.alarmContentType = ''
      if (val && val !== '') {
        this.fetchAlarmContentType()
      } else {
        this.alarmContentTypeList = []
      }
    },
    // 当时间范围变化时，填充listQuery时间
    timeRange(val) {
      if (val && val.length > 0) {
        this.listQuery.beginTime = val[0]
        this.listQuery.endTime = val[1]
      } else {
        this.listQuery.beginTime = ''
        this.listQuery.endTime = ''
      }
    }
  },
  created() {
    console.log('now created')
    this.fetchAlarmType()
    // this.fetchData()// 获取数据
  },
  activated() {
    console.log('now activated')
    this.listQuery.keywords = ''
    this.listQuery.alarmType = ''
    this.listQuery.alarmContentType = ''
    this.listQuery.beginTime = ''
    this.listQuery.endTime = ''
    this.timeRange = []
    this.fetchData(false)
  },
  methods: {
    // 取消报警
    cancelAlarm(jobId) {
      this.cancelShow = true
      // setTimeout(function() {
      this.$refs.handlePrompt.initDialog(true, jobId, false)
      // }, 100)
    },
    // 取消报警,调用结束工单接口
    batchCancel() {
      this.cancelShow = true
      // setTimeout(function() {
      this.$refs.handlePrompt.initDialog(true, '', true, this.listQuery)
      // }, 100)
    },
    formatValue(cellValue) {
      if (cellValue === 1) {
        return '一级告警'
      } else if (cellValue === 2) {
        return '二级告警'
      } else if (cellValue === 3) {
        return '三级告警'
      } else {
        return '--'
      }
    },
    // 计算行样式，不同等级显示不同颜色，暂时不用了
    tableRowClassName({ row, rowIndex }) {
      // if (row.alarmLevel === 1) {
      //   return 'red-row'
      // } else if (row.alarmLevel === 2) {
      //   return 'yellow-row'
      // }
      return ''
    },
    // 显示窨井详情
    showWellDetail(row) {
      this.wellShow = true
      this.$refs.wellInfo.initDialog(row.wellId)
    },
    // 批量导出
    batchExport() {
      // 全屏加载动画
      const loading = this.$loading({
        lock: true,
        text: '数据处理中,请稍后...',
        spinner: 'el-icon-loading',
        background: 'rgba(0, 0, 0, 0.7)'
      })
      batchExportAlarm(this.listQuery).then(res => {
        loading.close() // 关闭加载动画
        console.log('download===', res)
        const blob = new Blob([res.data])
        const downloadElement = document.createElement('a')
        const href = window.URL.createObjectURL(blob) // 创建下载的链接
        downloadElement.href = href
        downloadElement.download = `当前告警列表.xlsx` // 下载后文件名
        document.body.appendChild(downloadElement)
        downloadElement.click() // 点击下载
        document.body.removeChild(downloadElement) // 下载完成移除元素
        window.URL.revokeObjectURL(href) // 释放blob对象
      }).catch((res) => {
        loading.close()
        this.$message.error(res.message)
      })
    },
    checkCell(value) {
      return 'warning-state'
    },
    // 查询数据
    search() {
      this.fetchData(false)
    },
    // 获取数据
    fetchData(isNowPage = true) {
      this.listLoading = true
      if (!isNowPage) { // 是否显示当前页，否则跳转第一页
        this.listQuery.offset = 1
      }
      getAlarmList(this.listQuery).then(response => {
        this.list = response.data.rows
        this.total = parseInt(response.data.total)
        this.listLoading = false
      })
    },
    // 获取告警类型
    fetchAlarmType() {
      getAlarmType().then(response => {
        this.alarmTypeList = response.data
        if (!isOperation()) { // 如果不是管理员和运维人员
          this.showAlarmType = false
          this.listQuery.alarmType = '1'
        }
      })
    },
    // 获取告警内容类别
    fetchAlarmContentType() {
      this.alarmContentTypeList = []
      getAlarmContentType(this.listQuery.alarmType).then(response => {
        const supportDeviceTypes = this.$store.getters.deviceTypes
        for (const item of response.data.list) {
          if (supportDeviceTypes.indexOf(item.deviceType) !== -1) {
            this.alarmContentTypeList.push(item)
          }
        }
      })
    },
    indexMethod(index) {
      return this.listQuery.limit * (this.listQuery.offset - 1) + index + 1
    },
    // 改变页容量
    handleSizeChange(val) {
      this.listQuery.limit = val
      this.fetchData()
    },
    // 改变当前页
    handleCurrentChange(val) {
      this.listQuery.offset = val
      this.fetchData()
    }
  }
}
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
  $tableTitleHeight:46px;
  .table{
    margin-bottom: 20px;
  }
  .pagination-container{
    margin-bottom: 50px;
  }
  .table-title{
    background-color:rgba(243, 243, 243, 1);
    height: $tableTitleHeight;
    .title-header{
      line-height:$tableTitleHeight;
      color: #606266;
      font-size: 15px;
      i{
        margin-left: 5px;
        margin-right: 5px;
      }
    }
  }
  .edit_btns{
    .edit_btn{
      float:right;
      margin:7px 3px;//为了需要居中显示margin-top和bottom要用$tableTitleHeight减去按钮原高度除以2
    }
  }
  .warning-state{
    color:red
  }
</style>
<style rel="stylesheet/scss" lang="scss">
  .el-table {
    .red-row{
      background: #F9E9E8;
    }
    .orange-row{
      background: #F9E7D1;
    }
    .yellow-row{
      background: oldlace;
    }
  }
</style>
